CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000


obj
  io:           "CogOS_IO(Term)"
  remote:       "SignalDriver"
  
VAR
  long tmp

DAT
highTime      long 120,  40, 1240,   0,0,0,0,0,0,0,0,0,0,0,0,0
lowTime       long  40, 120,   40,   0,0,0,0,0,0,0,0,0,0,0,0,0
  
PUB RemotePower
  ' start the objects
  ' CogOS_IO(xxx) is an abstraction-layer or wrapper to map similar functions
  ' to ONE name. This way it's easy to exchange to a version that works with
  ' TV and keyboard ... or VGA and keyboard ... or FullDuplexSerial
  io.start( 0, 0 )

  ' wait until any key has been pushed. This way you can switch from Propeller Tool
  ' to PST without a hurry. At least during development all my terminal-based programs
  ' use this loop.
  tmp:=-1
  repeat while tmp==-1
    io.str( string( "RemotePower",$0d,"== please press key to start ==",$0d ) )
    tmp:=io.rxtime( 1000 )

  ' clear terminal screen and go home :o) (PST special)
  io.tx( 0 )
  io.tx( 1 )

  printAt( 2,1, string("RemotePower") )
  printAt( 1,2, string("=====================================",$0d) )

  remote.start( 0, %1 << 16, %1 << 16, 0 )
  dira[24]:=1
  outa[24]:=0
  remote.exec( remote#CMD_SETTAB, @highTime )
  waitcnt( clkfreq*2+cnt )
  repeat
    outa[24]:=1
    outa[24]:=0
    '                                                f0f0fff0fff0
    io.str(string("On",13))
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCd") )
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCd") )
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCd") )
    waitcnt( clkfreq*2+cnt )
    'remote.exec( remote#CMD_SIGOUT | 16<<16, string("AaBbAaAaAaBbAaAaAaBbAaBbAaBbAaAaAaBbAaBbAaBbAaAad") )
    io.str(string("Off",13))
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAbBaAaAcCd") )
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAbBaAaAcCd") )
    remote.exec( remote#CMD_SIGOUT | 16<<16, string("aAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAaAaAbBcCaAbBaAaAaAbBaAaAaAbBaAbBaAbBaAaAaAbBaAbBaAbBaAaAcCd") )
    waitcnt( clkfreq*2+cnt )
    'remote.exec( remote#CMD_SIGOUT | 16<<16, string("AaBbAaAaAaBbAaAaAaBbAaBbAaBbAaAaAaBbAaBbAaAaAaBbCcAaBbAaAaAaBbAaAaAaBbAaBbAaBbAaAaAaBbAaBbAaAaAaBbCcd") ) 
    'remote.exec( remote#CMD_SIGOUT | 16<<16, string("AaBbAaAaAaBbAaAaAaBbAaBbAaBbAaAaAaBbAaBbAaBbAaAad") )
    
PUB dec2( val ) | i
  i:=10
  if val>0
    repeat while val<>0
      i--
      num[i]:="0"+val//10
      val:=val/10

    io.str( (10-i)+ @zero )
    io.str( @num+i )
  else
    io.str( @zero )

  io.tx( $0d )

PUB dec( val, maxl ) | i
  i:=maxl
  num[maxl+1]:=0
  if val>0
    repeat while val<>0
      i--
      num[i]:="0"+val//10
      val:=val/10
    io.str( @num+i )
  else
    i--
    io.tx( "0" )

  repeat i
    io.tx( " " )

  io.tx( $0d )

dat
num  byte 0[11]
zero byte "0000000000",0  
  
pub at( x, y )
  ' set cursor position and print string
  posbuf[1]:=x
  posbuf[2]:=y
  posbuf[3]:=0
  io.str(@posbuf)

pub printAt(x, y, text)
  at( x, y )
  io.str( text )
  io.tx( $0d )
        
dat
' a buffer to assemble the bytestream for positioning
posbuf byte 2, 0, 0, 0, 0